Package tigase.xmpp.impl

# Class ServiceDiscovery

java.lang.Object
tigase.xmpp.XMPPProcessor
tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor
tigase.xmpp.XMPPProcessorAbstract
tigase.xmpp.impl.ServiceDiscovery

All Implemented Interfaces:
  `Comparable<XMPPImplIfc>`, `XMPPImplIfc`, `XMPPProcessorConcurrencyAwareIfc`, `XMPPProcessorIfc`

@Bean(name="disco", parent=SessionManager.class, active=true) public class ServiceDiscovery extends XMPPProcessorAbstract
Implementation of JEP-030.
Created: Mon Mar 27 20:45:36 2006

Author:
  Artur Hefczyc

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static interface`
  `ServiceDiscovery.AccountServiceProvider`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected static final String`
  `ID`

  ### Fields inherited from class tigase.xmpp.XMPPProcessor

  `ALL_NAMES, ALL_PATHS, cmpInfo`

  ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

  `CLIENT_XMLNS`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ServiceDiscovery()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `id()`
  Method `id` returns a unique ID of the plugin.
  `void`
  `process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
  `void`
  `processFromUserToServerPacket(JID connectionId, Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
  The method is called when a packet is send from the user who is owner of the session to the local server (ping, roster management, privacy lists, etc...).
  `void`
  `processNullSessionPacket(Packet packet, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
  The method is called for packets received by the server for which no user session is found - neither sender session or receiver session.
  `void`
  `processServerSessionPacket(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
  The method is called when a packet addressed to the server domain is received.
  `Element[]`
  `supDiscoFeatures(XMPPResourceConnection session)`
  Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request.
  `String[][]`
  `supElementNamePaths()`
  Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin.
  `String[]`
  `supNamespaces()`
  Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin.

  ### Methods inherited from class tigase.xmpp.XMPPProcessorAbstract

  `isFromUserSession, isNullSession, isServerSession, isToUserSession, processFromUserOutPacket, processFromUserPacket, processToUserPacket`

  ### Methods inherited from class tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor

  `supStreamFeatures, supTypes`

  ### Methods inherited from class tigase.xmpp.XMPPProcessor

  `canHandle, compareTo, concurrentQueuesNo, getComponentInfo, getInstance, getQueueSize, getStatistics, getThreadsNo, init, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Comparable

  `compareTo`

  ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

  `canHandle, concurrentQueuesNo, getComponentInfo, getStatistics, init, supStreamFeatures, supTypes`

- ## Field Details

  - ### ID

    protected static final String ID
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### ServiceDiscovery

    public ServiceDiscovery()

- ## Method Details

  - ### id

    public String id()
    Description copied from interface: `XMPPImplIfc`
    Method `id` returns a unique ID of the plugin. Each plugin has own, unique ID which is used in the configuration file to determine whether it needs to be loaded or not. In most cases the ID can be equal to XMLNS of the packages processed by the plugin.
    Specified by:
      `id` in interface `XMPPImplIfc`
    Overrides:
      `id` in class `AnnotatedXMPPProcessor`
    Returns:
      a `String` value

  - ### process

    public void process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings) throws XMPPException
    Specified by:
      `process` in interface `XMPPProcessorIfc`
    Overrides:
      `process` in class `XMPPProcessorAbstract`
    Parameters:
      `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
      `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
      `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
      `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
      `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
    Throws:
      `XMPPException`

  - ### processFromUserToServerPacket

    public void processFromUserToServerPacket(JID connectionId, Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings) throws PacketErrorTypeException
    Description copied from class: `XMPPProcessorAbstract`
    The method is called when a packet is send from the user who is owner of the session to the local server (ping, roster management, privacy lists, etc...). There is no default implementation for the method.
    Specified by:
      `processFromUserToServerPacket` in class `XMPPProcessorAbstract`
    Parameters:
      `connectionId` - is a `JID` instance with the session connection ID.
      `packet` - is a `Packet` sent by the user.
      `session` - is a `XMPPResourceConnection` instance with all the sending user session data.
      `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
      `results` - is a packets `Queue` with all the processing results from the plugin.
      `settings` - is a `Map` with all the configuration settings passed to the plugin.
    Throws:
      `PacketErrorTypeException` - on attempt to send an error response to the error packet.

  - ### processNullSessionPacket

    public void processNullSessionPacket(Packet packet, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings) throws PacketErrorTypeException
    Description copied from class: `XMPPProcessorAbstract`
    The method is called for packets received by the server for which no user session is found - neither sender session or receiver session. The default implementation does nothing, just ignores such a packet. To change the default behaviour the method has to be overwritten.
    Overrides:
      `processNullSessionPacket` in class `XMPPProcessorAbstract`
    Parameters:
      `packet` - is a `Packet` received by the server.
      `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
      `results` - is a packets `Queue` with all the processing results from the plugin.
      `settings` - is a `Map` with all the configuration settings passed to the plugin.
    Throws:
      `PacketErrorTypeException` - on attempt to send an error response to the error packet.

  - ### processServerSessionPacket

    public void processServerSessionPacket(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings) throws PacketErrorTypeException
    Description copied from class: `XMPPProcessorAbstract`
    The method is called when a packet addressed to the server domain is received. Please note, if a local user sends a packet to the server, the packet is handled by the `processFromUserPacket(...)` method. This method is not called for such packets.
    Specified by:
      `processServerSessionPacket` in class `XMPPProcessorAbstract`
    Parameters:
      `packet` - is a `Packet` received by the server and addressed to the server - the server virtual domain name.
      `session` - is a `XMPPResourceConnection` instance with all the server session data.
      `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
      `results` - is a packets `Queue` with all the processing results from the plugin.
      `settings` - is a `Map` with all the configuration settings passed to the plugin.
    Throws:
      `PacketErrorTypeException` - on attempt to send an error response to the error packet.

  - ### supDiscoFeatures

    public Element[] supDiscoFeatures(XMPPResourceConnection session)
    Description copied from interface: `XMPPImplIfc`
    Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request. Service discovery features returned by this method correspond to services supported by this plugin.
    Specified by:
      `supDiscoFeatures` in interface `XMPPImplIfc`
    Overrides:
      `supDiscoFeatures` in class `AnnotatedXMPPProcessor`
    Parameters:
      `session` - a `XMPPResourceConnection` value
    Returns:
      an `Element[]` value

  - ### supElementNamePaths

    public String[][] supElementNamePaths()
    Description copied from interface: `XMPPImplIfc`
    Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin. Each element name path corresponds to XMLNS returned in array by `supNamespaces()` method. The element path itself is represented by a String array with each path element as a separate String.
    Specified by:
      `supElementNamePaths` in interface `XMPPImplIfc`
    Overrides:
      `supElementNamePaths` in class `AnnotatedXMPPProcessor`
    Returns:
      a `String[][]` value is an array for element paths for which the plugin offers processing capabilities. Each path is in form of a String array in order to reduce parsing overhead.

  - ### supNamespaces

    public String[] supNamespaces()
    Description copied from interface: `XMPPImplIfc`
    Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin. Each namespace corresponds to element name returned in array by `supElemenets()` method.
    Specified by:
      `supNamespaces` in interface `XMPPImplIfc`
    Overrides:
      `supNamespaces` in class `AnnotatedXMPPProcessor`
    Returns:
      a `String[]` value